package ru.dbotthepony.mc.otm.menu.tech

import net.minecraft.world.Container
import kotlin.jvm.JvmOverloads
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.block.entity.tech.BatteryBankBlockEntity
import net.minecraft.world.SimpleContainer
import ru.dbotthepony.mc.otm.core.ImmutableList
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget
import ru.dbotthepony.mc.otm.capability.MatteryCapability
import ru.dbotthepony.mc.otm.core.orNull
import ru.dbotthepony.mc.otm.menu.BatterySlot
import ru.dbotthepony.mc.otm.menu.MatteryMenu
import ru.dbotthepony.mc.otm.menu.MatterySlot
import ru.dbotthepony.mc.otm.registry.MMenus

class BatteryBankMenu @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory,
	tile: BatteryBankBlockEntity? = null,
) : MatteryMenu(MMenus.BATTERY_BANK, p_38852_, inventory, tile) {
	val powerLevel: LevelGaugeWidget
	override val storageSlots: List<MatterySlot>

	init {
		val container: Container = tile?.container ?: SimpleContainer(BatteryBankBlockEntity.CAPACITY)
		powerLevel = LevelGaugeWidget(this, tile?.getCapability(MatteryCapability.ENERGY)?.orNull())

		storageSlots = ImmutableList(BatteryBankBlockEntity.CAPACITY) {
			val slot = BatterySlot(container, it)
			addSlot(slot)
			return@ImmutableList slot
		}

		addInventorySlots()
	}
}
